﻿/**
* PerformanceTest by Grant Skinner. Apr 21, 2009
* Visit www.gskinner.com/blog for documentation, updates and more free code.
*
*
* Copyright (c) 2009 Grant Skinner
* 
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use,
* copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following
* conditions:
* 
* The above copyright notice and this permission notice shall be
* included in all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
* HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
* OTHER DEALINGS IN THE SOFTWARE.
**/

package performancetests {
	
	public class Scope {
		
	// Constants:
		
	// Public Properties:
		// optional property specifying the default number of iterations to run each test in the suite.
		public var iterations:uint=5;
		// optional property specifying a description to be used when reporting on this test suite:
		public var description:String = "Testing impact of scope."
		
									
		
	// Protected Properties:
		// the number of loops to run in every test:
		protected var loops:uint = 5000000;
		
		// set up some variables used in the test:
		protected static const cA:Number = 10;
		protected static const cB:Number = 5;
		protected static var sA:Number = 10;
		protected static var sB:Number = 5;
		protected var iA:Number = 10;
		protected var iB:Number = 5;
		
	// Initialization:
		
	// Public getter / setters:
		
	// Public Methods:
		// tare method that will be run to calculate the base time required to run the loop
		// so it can be subtracted from the other test results.
		public function tare():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = 50;
			}
		}
		
		public function literals():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = 10*5+10+5/10;
			}
		}
	
		public function local():void {
			var lA:Number = 10;
			var lB:Number = 5;
			for (var i:uint=0; i<loops; i++) {
				var c:Number = lA*lB+lA+lB/lA;
			}
		}
		
		public function instance():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = iA*iB+iA+iB/iA;
			}
		}
		
		public function instanceExplicit():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = this.iA*this.iB+this.iA+this.iB/this.iA;
			}
		}
		
		public function staticVars():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = sA*sB+sA+sB/sA;
			}
		}
		
		public function staticExplicit():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = Scope.sA*Scope.sB+Scope.sA+Scope.sB/Scope.sA;
			}
		}
		
		public function constants():void {
			for (var i:uint=0; i<loops; i++) {
				var c:Number = cA*cB+cA+cB/cA;
			}
		}
		
	// Protected Methods:
		
	}
	
}